# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/http/cors/v3/cors.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass
from typing import (
    List,
    Optional,
)

import betterproto

from ......config.core import v3 as _____config_core_v3__
from ......type.matcher import v3 as _____type_matcher_v3__


@dataclass(eq=False, repr=False)
class Cors(betterproto.Message):
    """
    Cors filter config. Set this in ref:`http_filters <envoy_v3_api_field_exten
    sions.filters.network.http_connection_manager.v3.HttpConnectionManager.http
    _filters>` to enable the CORS filter. Please note that the :ref:`CorsPolicy
    <envoy_v3_api_msg_extensions.filters.http.cors.v3.CorsPolicy>` must be
    configured in the ``RouteConfiguration`` as ``typed_per_filter_config`` at
    some level to make the filter work.
    """

    pass


@dataclass(eq=False, repr=False)
class CorsPolicy(betterproto.Message):
    """
    Per route configuration for the CORS filter. This configuration should be
    configured in the ``RouteConfiguration`` as ``typed_per_filter_config`` at
    some level to make the filter work. [#next-free-field: 10]
    """

    allow_origin_string_match: List[
        "_____type_matcher_v3__.StringMatcher"
    ] = betterproto.message_field(1)
    """
    Specifies string patterns that match allowed origins. An origin is allowed
    if any of the string matchers match.
    """

    allow_methods: str = betterproto.string_field(2)
    """
    Specifies the content for the ``access-control-allow-methods`` header.
    """

    allow_headers: str = betterproto.string_field(3)
    """
    Specifies the content for the ``access-control-allow-headers`` header.
    """

    expose_headers: str = betterproto.string_field(4)
    """
    Specifies the content for the ``access-control-expose-headers`` header.
    """

    max_age: str = betterproto.string_field(5)
    """Specifies the content for the ``access-control-max-age`` header."""

    allow_credentials: Optional[bool] = betterproto.message_field(
        6, wraps=betterproto.TYPE_BOOL
    )
    """Specifies whether the resource allows credentials."""

    filter_enabled: "_____config_core_v3__.RuntimeFractionalPercent" = (
        betterproto.message_field(7)
    )
    """
    Specifies the % of requests for which the CORS filter is enabled. If
    neither ``filter_enabled``, nor ``shadow_enabled`` are specified, the CORS
    filter will be enabled for 100% of the requests. If :ref:`runtime_key
    <envoy_v3_api_field_config.core.v3.RuntimeFractionalPercent.runtime_key>`
    is specified, Envoy will lookup the runtime key to get the percentage of
    requests to filter.
    """

    shadow_enabled: "_____config_core_v3__.RuntimeFractionalPercent" = (
        betterproto.message_field(8)
    )
    """
    Specifies the % of requests for which the CORS policies will be evaluated
    and tracked, but not enforced. This field is intended to be used when
    ``filter_enabled`` is off. That field have to explicitly disable the filter
    in order for this setting to take effect. If :ref:`runtime_key
    <envoy_v3_api_field_config.core.v3.RuntimeFractionalPercent.runtime_key>`
    is specified, Envoy will lookup the runtime key to get the percentage of
    requests for which it will evaluate and track the request's ``Origin`` to
    determine if it's valid but will not enforce any policies.
    """

    allow_private_network_access: Optional[bool] = betterproto.message_field(
        9, wraps=betterproto.TYPE_BOOL
    )
    """
    Specify whether allow requests whose target server's IP address is more
    private than that from which the request initiator was fetched. More
    details refer to https://developer.chrome.com/blog/private-network-access-
    preflight.
    """
