# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/http/decompressor/v3/decompressor.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass
from typing import Optional

import betterproto

from ......config.core import v3 as _____config_core_v3__


@dataclass(eq=False, repr=False)
class Decompressor(betterproto.Message):
    decompressor_library: "_____config_core_v3__.TypedExtensionConfig" = (
        betterproto.message_field(1)
    )
    """
    A decompressor library to use for both request and response decompression.
    Currently only :ref:`envoy.compression.gzip.compressor<envoy_v3_api_msg_ext
    ensions.compression.gzip.decompressor.v3.Gzip>` is included in Envoy.
    [#extension-category: envoy.compression.decompressor]
    """

    request_direction_config: "DecompressorRequestDirectionConfig" = (
        betterproto.message_field(2)
    )
    """
    Configuration for request decompression. Decompression is enabled by
    default if left empty.
    """

    response_direction_config: "DecompressorResponseDirectionConfig" = (
        betterproto.message_field(3)
    )
    """
    Configuration for response decompression. Decompression is enabled by
    default if left empty.
    """


@dataclass(eq=False, repr=False)
class DecompressorCommonDirectionConfig(betterproto.Message):
    """
    Common configuration for filter behavior on both the request and response
    direction.
    """

    enabled: "_____config_core_v3__.RuntimeFeatureFlag" = betterproto.message_field(1)
    """
    Runtime flag that controls whether the filter is enabled for decompression
    or not. If set to false, the filter will operate as a pass-through filter.
    If the message is unspecified, the filter will be enabled.
    """

    ignore_no_transform_header: bool = betterproto.bool_field(2)
    """
    If set to true, will decompress response even if a ``no-transform`` cache
    control header is set.
    """


@dataclass(eq=False, repr=False)
class DecompressorRequestDirectionConfig(betterproto.Message):
    """Configuration for filter behavior on the request direction."""

    common_config: "DecompressorCommonDirectionConfig" = betterproto.message_field(1)
    advertise_accept_encoding: Optional[bool] = betterproto.message_field(
        2, wraps=betterproto.TYPE_BOOL
    )
    """
    If set to true, and response decompression is enabled, the filter modifies
    the Accept-Encoding request header by appending the decompressor_library's
    encoding. Defaults to true.
    """


@dataclass(eq=False, repr=False)
class DecompressorResponseDirectionConfig(betterproto.Message):
    """Configuration for filter behavior on the response direction."""

    common_config: "DecompressorCommonDirectionConfig" = betterproto.message_field(1)
