# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/listener/proxy_protocol/v3/proxy_protocol.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass
from typing import List

import betterproto

from ......config.core import v3 as _____config_core_v3__


@dataclass(eq=False, repr=False)
class ProxyProtocol(betterproto.Message):
    rules: List["ProxyProtocolRule"] = betterproto.message_field(1)
    """The list of rules to apply to requests."""

    allow_requests_without_proxy_protocol: bool = betterproto.bool_field(2)
    """
    Allow requests through that don't use proxy protocol. Defaults to false. ..
    attention::   This breaks conformance with the specification.   Only enable
    if ALL traffic to the listener comes from a trusted source.   For more
    information on the security implications of this feature, see
    https://www.haproxy.org/download/2.1/doc/proxy-protocol.txt .. attention::
    Requests of 12 or fewer bytes that match the proxy protocol v2 signature
    and requests of 6 or fewer bytes that match the proxy protocol v1
    signature will timeout (Envoy is unable to differentiate these requests
    from incomplete proxy protocol requests).
    """

    pass_through_tlvs: "_____config_core_v3__.ProxyProtocolPassThroughTlVs" = (
        betterproto.message_field(3)
    )
    """
    This config controls which TLVs can be passed to filter state if it is
    Proxy Protocol V2 header. If there is no setting for this field, no TLVs
    will be passed through. .. note::   If this is configured, you likely also
    want to set   :ref:`core.v3.ProxyProtocolConfig.pass_through_tlvs
    <envoy_v3_api_field_config.core.v3.ProxyProtocolConfig.pass_through_tlvs>`,
    which controls pass-through for the upstream.
    """


@dataclass(eq=False, repr=False)
class ProxyProtocolKeyValuePair(betterproto.Message):
    metadata_namespace: str = betterproto.string_field(1)
    """
    The namespace — if this is empty, the filter's namespace will be used.
    """

    key: str = betterproto.string_field(2)
    """The key to use within the namespace."""


@dataclass(eq=False, repr=False)
class ProxyProtocolRule(betterproto.Message):
    """
    A Rule defines what metadata to apply when a header is present or missing.
    """

    tlv_type: int = betterproto.uint32_field(1)
    """
    The type that triggers the rule - required TLV type is defined as uint8_t
    in proxy protocol. See `the spec
    <https://www.haproxy.org/download/2.1/doc/proxy-protocol.txt>`_ for
    details.
    """

    on_tlv_present: "ProxyProtocolKeyValuePair" = betterproto.message_field(2)
    """If the TLV type is present, apply this metadata KeyValuePair."""
