# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/http/custom_response/redirect_policy/v3/redirect_policy.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass
from typing import (
    List,
    Optional,
)

import betterproto

from ......config.core import v3 as _____config_core_v3__
from ......config.route import v3 as _____config_route_v3__


@dataclass(eq=False, repr=False)
class RedirectPolicy(betterproto.Message):
    """
    Custom response policy to internally redirect the original response to a
    different upstream. [#next-free-field: 7]
    """

    uri: str = betterproto.string_field(1, group="redirect_action_specifier")
    """
    The Http URI to redirect the original request to, to get the custom
    response. It should be a full FQDN with protocol, host and path. Example:
    .. code-block:: yaml    uri: https://www.mydomain.com/path/to/404.txt
    """

    redirect_action: "_____config_route_v3__.RedirectAction" = (
        betterproto.message_field(2, group="redirect_action_specifier")
    )
    """
    Specify elements of the redirect url individually. Note: Do not specify the
    `response_code` field in `redirect_action`, use `status_code` instead. The
    following fields in `redirect_action` are currently not supported, and
    specifying them will cause the config to be rejected: - `prefix_rewrite` -
    `regex_rewrite`
    """

    status_code: Optional[int] = betterproto.message_field(
        3, wraps=betterproto.TYPE_UINT32
    )
    """
    The new response status code if specified. This is used to override the
    status code of the response from the new upstream if it is not an error
    status.
    """

    response_headers_to_add: List[
        "_____config_core_v3__.HeaderValueOption"
    ] = betterproto.message_field(4)
    """
    HTTP headers to add to the response. This allows the response policy to
    append, to add or to override headers of the original response for local
    body, or the custom response from the remote body, before it is sent to a
    downstream client. Note that these are not applied if the redirected
    response is an error response.
    """

    request_headers_to_add: List[
        "_____config_core_v3__.HeaderValueOption"
    ] = betterproto.message_field(5)
    """
    HTTP headers to add to the request before it is internally redirected.
    """

    modify_request_headers_action: "_____config_core_v3__.TypedExtensionConfig" = (
        betterproto.message_field(6)
    )
    """
    Custom action to modify request headers before selection of the redirected
    route. [#comment: TODO(pradeepcrao) add an extension category.]
    """
