# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: udpa/annotations/migrate.proto, udpa/annotations/security.proto, udpa/annotations/sensitive.proto, udpa/annotations/status.proto, udpa/annotations/versioning.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass

import betterproto


class PackageVersionStatus(betterproto.Enum):
    UNKNOWN = 0
    """Unknown package version status."""

    FROZEN = 1
    """This version of the package is frozen."""

    ACTIVE = 2
    """This version of the package is the active development version."""

    NEXT_MAJOR_VERSION_CANDIDATE = 3
    """
    This version of the package is the candidate for the next major version. It
    is typically machine generated from the active development version.
    """


@dataclass(eq=False, repr=False)
class StatusAnnotation(betterproto.Message):
    work_in_progress: bool = betterproto.bool_field(1)
    """The entity is work-in-progress and subject to breaking changes."""

    package_version_status: "PackageVersionStatus" = betterproto.enum_field(2)
    """The entity belongs to a package with the given version status."""


@dataclass(eq=False, repr=False)
class MigrateAnnotation(betterproto.Message):
    rename: str = betterproto.string_field(1)
    """Rename the message/enum/enum value in next version."""


@dataclass(eq=False, repr=False)
class FieldMigrateAnnotation(betterproto.Message):
    rename: str = betterproto.string_field(1)
    """Rename the field in next version."""

    oneof_promotion: str = betterproto.string_field(2)
    """
    Add the field to a named oneof in next version. If this already exists, the
    field will join its siblings under the oneof, otherwise a new oneof will be
    created with the given name.
    """


@dataclass(eq=False, repr=False)
class FileMigrateAnnotation(betterproto.Message):
    move_to_package: str = betterproto.string_field(2)
    """
    Move all types in the file to another package, this implies changing proto
    file path.
    """


@dataclass(eq=False, repr=False)
class VersioningAnnotation(betterproto.Message):
    previous_message_type: str = betterproto.string_field(1)
    """
    Track the previous message type. E.g. this message might be
    udpa.foo.v3alpha.Foo and it was previously udpa.bar.v2.Bar. This
    information is consumed by UDPA via proto descriptors.
    """


@dataclass(eq=False, repr=False)
class FieldSecurityAnnotation(betterproto.Message):
    """
    These annotations indicate metadata for the purpose of understanding the
    security significance of fields.
    """

    configure_for_untrusted_downstream: bool = betterproto.bool_field(1)
    """Field should be set in the presence of untrusted downstreams."""

    configure_for_untrusted_upstream: bool = betterproto.bool_field(2)
    """Field should be set in the presence of untrusted upstreams."""
